---
title: RTCRtpEncodingParameters
slug: Web/API/RTCRtpEncodingParameters
tags:
  - API
  - Codec
  - Codec Configuration
  - Dictionary
  - Encoding
  - RTCRtpEncodingParameters
  - RTP
  - Reference
  - Settings
  - WebRTC
  - WebRTC API
  - parameters
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">An instance of the <a href="/en-US/docs/Web/API/WebRTC_API">WebRTC</a> API's <strong><code>RTCRtpEncodingParameters</code></strong> dictionary describes a single configuration of a {{Glossary("codec")}} for an {{domxref("RTCRtpSender")}}.</span> It's used in the {{domxref("RTCRtpSendParameters")}} describing the configuration of an RTP sender's {{domxref("RTCRtpSendParameters.encodings", "encodings")}}; {{domxref("RTCRtpDecodingParameters")}} is used to describe the configuration of an RTP receiver's {{domxref("RTCRtpReceiveParamters", "encodings")}}.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("RTCRtpEncodingParameters.active", "active")}}</dt>
 <dd>If <code>true</code>, the described encoding is currently actively being used. That is, for RTP senders, the encoding is currently being used to send data, while for receivers, the encoding is being used to decode received data. The default value is <code>true</code>.</dd>
 <dt>{{domxref("RTCRtpEncodingParameters.codecPayloadType", "codecPayloadType")}}</dt>
 <dd>When describing a codec for an {{domxref("RTCRtpSender")}}, <code>codecPayloadType</code> is a single 8-bit byte (or octet) specifying the codec to use for sending the stream; the value matches one from the owning {{domxref("RTCRtpParameters")}} object's {{domxref("RTCRtpParameters.codecs", "codecs")}} parameter. This value can only be set when creating the transceiver; after that, this value is read only.</dd>
 <dt>{{domxref("RTCRtpEncodingParameters.dtx", "dtx")}}</dt>
 <dd>Only used for an {{domxref("RTCRtpSender")}} whose {{domxref("MediaStreamTrack.kind", "kind")}} is <code>audio</code>, this property indicates whether or not to use discontinuous transmission (a feature by which a phone is turned off or the microphone muted automatically in the absence of voice activity). The value is taken from the enumerated string type {{domxref("RTCDtxStatus")}}.</dd>
 <dt>{{domxref("RTCRtpEncodingParameters.maxBitrate", "maxBitrate")}}</dt>
 <dd>An unsigned long integer indicating the maximum number of bits per second to allow for this encoding. Other parameters may further constrain the bit rate, such as the value of <code>maxFramerate</code> or transport or physical network limitations.</dd>
 <dt>{{domxref("RTCRtpEncodingParameters.maxFramerate", "maxFramerate")}}</dt>
 <dd>A double-precision floating-point value specifying the maximum number of frames per second to allow for this encoding.</dd>
 <dt>{{domxref("RTCRtpEncodingParameters.ptime", "ptime")}}</dt>
 <dd>An unsigned long integer value indicating the preferred duration of a media packet in milliseconds. This is typically only relevant for audio encodings. The user agent will try to match this as well as it can, but there is no guarantee.</dd>
 <dt>{{domxref("RTCRtpEncodingParameters.rid", "rid")}}</dt>
 <dd>A {{domxref("DOMString")}} which, if set, specifies an <strong>RTP stream ID</strong> (<strong>RID</strong>) to be sent using the RID header extension. This parameter cannot be modified using {{domxref("RTCRtpSender.setParameters", "setParameters()")}}. Its value can only be set when the transceiver is first created.</dd>
 <dt>{{domxref("RTCRtpEncodingParameters.scaleResolutionDownBy", "scaleResolutionDownBy")}}</dt>
 <dd>Only used for senders whose track's {{domxref("MediaStreamTrack.kind", "kind")}} is <code>video</code>, this is a double-precision floating-point value specifying a factor by which to scale down the video during encoding. The default value, 1.0, means that the sent video's size will be the same as the original. A value of 2.0 scales the video frames down by a factor of 2 in each dimension, resulting in a video 1/4 the size of the original. The value must not be less than 1.0 (you can't use this to scale the video up).</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC 1.0','#dom-rtcrtpencodingparameters','RTCRtpEncodingParameters')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCRtpEncodingParameters")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Intro_to_RTP">Introduction to the Real-time Transport Protocol (RTP)</a></li>
 <li>{{domxref("RTCRtpSender")}}, {{domxref("RTCRtpReceiver")}}, and {{domxref("RTCRtpTransceiver")}}</li>
</ul>
